前往小程序,Get更优阅读体验!
立即前往
首页
学习
活动
专区
工具
TVP
发布
社区首页 >专栏 >LeetCode-26.Remove Duplicates from Sorted Array | 删除排序数组中的重复项

LeetCode-26.Remove Duplicates from Sorted Array | 删除排序数组中的重复项

作者头像
Zoctopus
发布2021-02-25 17:15:32
4440
发布2021-02-25 17:15:32
举报

题目

Given a sorted array nums, remove the duplicates in-place such that each element appears only once and returns the new length.

Do not allocate extra space for another array, you must do this by modifying the input array in-place with O(1) extra memory.

Clarification:

Confused why the returned value is an integer but your answer is an array?

Note that the input array is passed in by reference, which means a modification to the input array will be known to the caller as well.

Internally you can think of this:

代码语言:javascript
复制
// nums is passed in by reference. (i.e., without making a copy)
int len = removeDuplicates(nums);

// any modification to nums in your function would be known by the caller.
// using the length returned by your function, it prints the first len elements.
for (int i = 0; i < len; i++) {
    print(nums[i]);
}
代码语言:javascript
复制
Example 1:

Input: nums = [1,1,2]
Output: 2, nums = [1,2]
Explanation: Your function should return length = 2, with the first two elements of nums being 1 and 2 respectively. It doesn't matter what you leave beyond the returned length.

Example 2:

Input: nums = [0,0,1,1,1,2,2,3,3,4]
Output: 5, nums = [0,1,2,3,4]
Explanation: Your function should return length = 5, with the first five elements of nums being modified to 0, 1, 2, 3, and 4 respectively. It doesn't matter what values are set beyond the returned length.

Constraints:
0 <= nums.length <= 3 * 104
-104 <= nums[i] <= 104
nums is sorted in ascending order.

题解

这道题就是希望让我返回一个没有重复数字的数组的大小,且不要使用额外的数组空间,必须在原地修改输入数组 并在使用 O(1) 额外空间的条件下完成。

解法一:暴力

for循环从数组nums末尾的最后一个数字开始遍历,让数组nums末尾最后一个数字与末尾最后倒数第二个数字做比较,如果后一个等于前一个,则从数组中删除后一个元素,直到遍历完成,返回新数组的长度。

代码语言:javascript
复制
//Go
func removeDuplicates(nums []int) int {
	for i:=len(nums)-1;i>0;i-- {
        if nums[i] == nums[i-1] {
            nums = append(nums[:i],nums[i+1:]...)
        }
    }

    return len(nums)
}

解法二:双指针法

代码语言:javascript
复制
//Go
func removeDuplicates(nums []int) int {
    if len(nums) == 0 {  //考虑特殊情况
        return 0
    }
    i := 0; //慢指针
    for j := 1;j < len(nums);j++ {  //j是快指针
        if nums[j] != nums[i] {
            i++
            nums[i] = nums[j]
        }
    }
    return i + 1
}

执行结果:

代码语言:javascript
复制
leetcode-cn:
执行用时:8 ms, 在所有 Go 提交中击败了86.25%的用户
内存消耗:4.6 MB, 在所有 Go 提交中击败了65.76%的用户

leetcode:
Runtime: 4 ms, faster than 99.38% of Go online submissions for Remove Duplicates from Sorted Array.
Memory Usage: 4.6 MB, less than 100.00% of Go online submissions for Remove Duplicates from Sorted Array.
本文参与 腾讯云自媒体分享计划,分享自作者个人站点/博客。
原始发表:2021-02-10 ,如有侵权请联系 cloudcommunity@tencent.com 删除

本文分享自 作者个人站点/博客 前往查看

如有侵权,请联系 cloudcommunity@tencent.com 删除。

本文参与 腾讯云自媒体分享计划  ,欢迎热爱写作的你一起参与!

评论
登录后参与评论
0 条评论
热度
最新
推荐阅读
目录
  • 题目
  • 题解
    • 解法一:暴力
      • 解法二:双指针法
      领券
      问题归档专栏文章快讯文章归档关键词归档开发者手册归档开发者手册 Section 归档